; SketchyLISP Extension Library
; Copyright (C) 2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; assp

; ---conformance---
; R5.91RS

; ---purpose---
; Retrieve an association from an association list.
; An association list is a list of pairs where
; the
; .E car
; part of each pair holds a key and the
; .E cdr
; part of the pair holds the value
; associated with that key:
; .B
; .C ((key1 . value1) ... (keyN . valueN))
; .B
; .C Assp
; returns the first association whose key matches a given
; predicate.

; ---args---
; P - predicate
; A - association list

; ---keywords---
; ASSP function, association lists, alists, associate

; ---see-also---
; assoc, assq, assv, memp

; ---example---
; (assp even? '((1 . i) (2 . ii) (3 . iii) (4 . iv))) => (2 . ii)

(define assp #t)

; (require "nullp.scm") ; null?
; (require "caar.scm") ; cdar

; ---code---
(define (assp p a)
  (cond ((null? a) #f)
    ((p (caar a)) (car a))
    (else (assp p (cdr a)))))
