; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; ordered?

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Check whether the members of a list
; are in a given monotonic order.

; ---args---
; P - predicate defining order
; X - list

; ---keywords---
; ORDERED? function, ordered, ordering, relation
; lists, predicate

; ---see-also---
; qsort

; ---example---
; (ordered? > '(9 8 7 6 5)) => #t

; (require "nullp.scm") ; null?
; (require "lib/caar.scm") ; cadr

; ---code---
(define (ordered? p x)
  (or (null? x)
      (null? (cdr x))
      (and (p (car x) (cadr x))
           (ordered? p (cdr x)))))
