; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; remove

; ---conformance---
; R5.91RS

; ---purpose---
; Remove data from lists.

; ---args---
; X - datum to remove
; A - list

; ---keywords---
; REMOVE function, lists, sets, set theory, member, remove

; ---see-also---
; remv, remq, member, equal?

; ---example---
; (remove '(x) '((x) (y) (z) (x))) => ((y) (z))

(define remove #t)

; (require "nullp.scm") ; null?
; (require "lib/equalp.scm") ; equal?
; (require "lib/not.scm")
(require "filter.scm")

; ---model---
; (define (remove x a)
;   (cond ((null? a) '())
;     ((equal? x (car a)) (cdr a))
;     (else (cons (car a) (remove x (cdr a))))))

; ---code---
(define (remove x a)
  (filter (lambda (y)
            (not (equal? x y)))
          a))
