; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; union

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Compute the union of sets.
; Sets are represented by lists
; of unique members.

; ---args---
; A*... - sets

; ---keywords---
; UNION function, union, sets, set theory

; ---see-also---
; intersection, unique, member

; ---example---
; (union '(a b c) '(b c d) '(c d e)) => (a b c d e)

; (require "lib/append.scm")
(require "unique.scm")

; ---code---
(define (union . a*)
  (unique (apply append a*)))
