; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; append

; ---conformance---
; R5RS

; ---purpose---
; Append lists. The last argument to append may be an atom,
; resulting in an improper list.

; ---args---
; A... - lists

; ---keywords---
; APPEND function, lists, appending

; ---see-also---
; reverse, length, map, equal?, list?

; ---example---
; (append '(a b) '(c d) '(e f)) => (a b c d e f)

(define append #t)

; (require "nullp.scm") ; null?
(require "reverse.scm")
(require "fold-left.scm")

; ---code---
(define (append . a)
  (letrec
    ((append2
       (lambda (a b)
         (cond ((null? a) b)
           (else (append2 (cdr a) (cons (car a) b))))))
     (_append
       (lambda (a b)
         (cond ((null? b) a)
           (else (append2 (reverse a) b))))))
    (fold-left _append '() a)))
