; SketchyLISP Library
; Copyright (C) 2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; case

; ---conformance---
; R5RS

; ---purpose---
; Select cases.

; ---args---
; KEY - key used to select a case
; DATA - possible matches for this case
; EXPR - value for this case

; ---keywords---
; CASE syntax, conditional evaluation, case selection

; ---see-also---
; if

; ---example---
; ; Example needs pre-loaded image
; (case 'c ((a b) 'a-or-b) ((c d) 'c-or-d)) --> c-or-d

(require "if.scm")
(require "memv.scm")

; ---code---
(define-syntax case
  (syntax-rules (else)
    ((_ key (else expr))
       expr)
    ((_ key (data expr))
       (if (memv key 'data)
           expr
           (bottom '(no default in case))))
    ((_ key (data1 expr1) (data2 expr2) ...)
       (if (memv key 'data1)
           expr1
           (case key (data2 expr2) ...)))))
