; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; let*

; ---conformance---
; R5RS

; ---purpose---
; Bind values sequentially.
; .B
; .C (let* ((a 1) (b a)) b)
; .B
; equals
; .B
; .C (let ((a 1)) (let ((b a)) b))

; ---args---
; N - name
; V - value
; X - expression (body)

; ---keywords---
; LET*, binding, sequential

; ---see-also---

; ---example---
; ; Example needs pre-loaded image
; (let* ((a 1) (b (+ 1 a))) b) --> 2

; ---code---
(define-syntax let*
  (syntax-rules ()
    ((_ () x)
       (let () x))
    ((_ ((n v)) x)
       (let ((n v)) x))
    ((_ ((n1 v1) (n2 v2) ...) x)
       (let ((n1 v1))
         (let* ((n2 v2) ...) x)))))
