; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; nqoutient

; ---conformance---
; SketchyLISP Core

; ---purpose---
; Divide two natural numbers. Return the integer part of their quotient.

; ---args---
; A - natural number (dividend)
; B - natural number (divisor)

; ---keywords---
; NQUOTIENT function, quotient, divide, division
; arithmetics, natural

; ---see-also---
; digits, ndivide, nremainder, n*, n+, n-, quotient

; ---example---
; (nquotient 11 4) => 2

(define nquotient #t)

(require "ndivide.scm")

; ---code---
(define (nquotient a b)
  (car (ndivide a b)))
