; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; zero?

; ---conformance---
; R5RS

; ---purpose---
; Test whether a number is zero.

; ---args---
; X - number

; ---keywords---
; ZERO? function, zero, numbers, digit, equivalence
; identity, predicate

; ---see-also---
; digits, even?, negative?, positive?

; ---example---
; (zero? 0) => #t

(define zerop #t)

; (require "nullp.scm") ; null?
(require "digits.scm") ; 0d
(require "equal.scm") ; =

; ---model---
; (define (zero? x)
;   (= x 0))

; ---code---
(define (zero? x)
  (letrec
    ((zerop
       (lambda (list-x)
         (cond ((eq? (car list-x) 0d)
             (null? (cdr list-x)))
           (else (= x 0))))))
    (zerop (integer->list x))))
